'***********************************************************************
'*                              N O K E Y B                            *
'*---------------------------------------------------------------------*
'*    Montre comment effacer le buffer du clavier pour protger        *
'*    l'utilisateur contre des saisies rsiduelles lorsqu'il doit      *
'*    rpondre  des questions importantes (par ex "Voulez-vous        *
'*    supprimer tel fichier ?")                                        *
'*---------------------------------------------------------------------*
'* Auteur                : MICHAEL TISCHER                             *
'* Dvelopp le          : 01.01.1992                                  *
'* Dernire modification : 01.01.1992                                  *
'***********************************************************************
'
DECLARE SUB ClearKbBuffer ()
'-- Programme principal ------------------------------------------------

DIM i AS INTEGER                                  'Compteur d'itrations

CLS
PRINT ("NOKEYB  -  (c) 1992 by Michael Tischer")
PRINT
PRINT ("A 0 les caractres du buffer vont tre effacs.")
PRINT

FOR i = 10 TO 0 STEP -1                'le temps de taper des caractres
  PRINT i; "     "
  SLEEP 1
NEXT

ClearKbBuffer                                 'Vide le buffer du clavier

'--- Affiche les caractres qui restent dans le buffer------------------

ccount = 0                                      'Pas encore de caractre
PRINT
PRINT
PRINT ("Caractres dans le buffer:")

DO                                                      'En reste-t-il ?
  a$ = INKEY$
  IF a$ <> "" THEN
    FOR i = 1 TO LEN(a$)
      PRINT "   "; ASC(MID$(a$, i, 1)),         'Affiche d'abord le code
      IF ASC(MID$(a$, i, 1)) > 32 THEN              'Caractre spcial ?
        PRINT "("; MID$(a$, i, 1); ")";       'Non, affiche le caractre
      END IF
      PRINT
      ccount = ccount + 1
    NEXT
  END IF
LOOP WHILE a$ <> ""

IF ccount = 0 THEN                                   'Pas de caractre ?
  PRINT ("(Aucun)")                                                 'Non
END IF
PRINT

END

'***********************************************************************
'* ClearKbBuffer : Efface le contenu du buffer du clavier              *
'* Entre: nant                                                       *
'* Sortie: nant                                                       *
'***********************************************************************
'
SUB ClearKbBuffer

DO           'Retire les caractres du buffer jusqu' ce qu'il soit vide
LOOP WHILE INKEY$ <> ""

END SUB

