;**********************************************************************;
;*                         L O G O C A . A S M                        *;
;*--------------------------------------------------------------------*;
;*    Fonction       : dfinit un jeu de caractres personnaliss     *;
;*                      pour les cartes EGA et VGA                    *;
;*--------------------------------------------------------------------*;
;*    Auteur         : MICHAEL TISCHER                                *;
;*    Dvelopp le   :  7.08.1990                                     *;
;*    Dernire MAJ   : 14.02.1992                                     *;
;*--------------------------------------------------------------------*;
;*    Assemblage     : TASM -mx logoca     ou MASM -mx logoca;        *;
;**********************************************************************;

      DOSSEG                               ; Ordre des segments habituel
      .MODEL SMALL, C                      ; Prpare l'inclusion du code
                                   ; dans un programme C en modle SMALL

      PUBLIC defchar

;== Code ===============================================================

      .CODE

;-- DEFCHAR : fixe les motifs des caractres pour cartes EGA et VGA
;--
;-- Dclaration en C : void defchar( BYTE ascii, BYTE table, BYTE height
;--                                  BYTE nombre, void far * buf );
;-- Entres          : ASCII  = Numro du 1er caractre  dfinir
;--                    TABL   = Numro de la table des caractres
;--                    HEIGHT = Hauteur des caractres (lignes de trame)
;--                    NOMBRE = Nombre de caractres
;--                    BUF    = Pointeur Far sur le buffer
;-- Sortie           : nant

defchar   proc ascii:byte,  tabl:byte, height:byte, \
               nombre:byte, buf:dword

      mov  ax,1100h            ; Appelle l'option 00h de la fonction 11h
      mov  bh,height                  ; Charge les paramtres appropris
      mov  bl,tabl                                  ; dans les registres
      mov  dl,ascii
      xor  dh,dh
      mov  cl,nombre
      mov  ch,dh

      push bp                  ; Mmorise BP pour l'adressage de la pile
      les  bp,buf
      int  10h                       ; Appelle l'interruption vido BIOS
      pop  bp                                     ; Rcupre l'ancien BP

      ret                                        ; Retourne  l'appelant

defchar   endp

;== Fin ================================================================
          end
